#!/bin/bash


PREFIX=/etc/dtlogin-sessions
FILESOK=1

TMPL=templates
FILE1=enable-template-desktop.sh
FILE2=disable-template-desktop.sh
FILE3=Xinitrc.template
FILE4=Xsession.template
FILE5=Xresources.template
FILE6=dtlogin-template


if [ "x$1" == "x" ]
then
	echo "Desktop name required"
else
	DESKNAME="$1"
	DESTDIR=$PREFIX/$DESKNAME-desktop
	
	for i in $FILE1 $FILE2 $FILE3 $FILE4 $FILE5 $FILE6.bm $FILE6.pm
	do
		if [ ! -f $TMPL/$i ]
		then
			FILESOK=0
			echo "$TMPL/$i not found"
		fi
	done
	
	if [ "$FILESOK" == "1" ]
	then
		if [ -d $DESTDIR ]
		then
			echo "directory $DESTDIR exists"
		else
			echo "Creating $DESTDIR for $DESKNAME login"
			
			mkdir -p $DESTDIR/etc/dt/config/C/Xresources.d
			mkdir -p $DESTDIR/etc/dt/appconfig/icons/C
			
			cp $TMPL/$FILE6.bm $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.bm
			cp $TMPL/$FILE6.pm $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.pm
			
			cat $TMPL/$FILE1 \
			| sed "s/\$template/$DESKNAME/g" \
			> $DESTDIR/enable-$DESKNAME-desktop.sh
			chmod 755 $DESTDIR/enable-$DESKNAME-desktop.sh

			cat $TMPL/$FILE2 \
			| sed "s/\$template/$DESKNAME/g" \
			> $DESTDIR/disable-$DESKNAME-desktop.sh
			chmod 755 $DESTDIR/disable-$DESKNAME-desktop.sh
			
			cat $TMPL/$FILE3 \
			| sed "s/\$template/$DESKNAME/g" \
			> $DESTDIR/etc/dt/config/Xinitrc.$DESKNAME
			chmod 755 $DESTDIR/etc/dt/config/Xinitrc.$DESKNAME
			
			cat $TMPL/$FILE4 \
			| sed "s/\$template/$DESKNAME/g" \
			> $DESTDIR/etc/dt/config/Xsession.$DESKNAME
			chmod 755 $DESTDIR/etc/dt/config/Xsession.$DESKNAME
			
			cat $TMPL/$FILE5 \
			| sed "s/\$template/$DESKNAME/g" \
			> $DESTDIR/etc/dt/config/C/Xresources.d/Xresources.$DESKNAME
			chmod 755 $DESTDIR/etc/dt/config/C/Xresources.d/Xresources.$DESKNAME
			
			if [ ! -f /usr/bin/start$DESKNAME ]
			then
				echo "Missing startscript /usr/bin/start$DESKNAME."
				if [ -f $TMPL/starttemplate ]
				then
					echo "Creating /usr/bin/start$DESKNAME from template"
					cat $TMPL/starttemplate \
					| sed "s/\$template/$DESKNAME/g" \
					> /usr/bin/start$DESKNAME
					chmod 755 /usr/bin/start$DESKNAME
					
					echo "You should edit the startscript /usr/bin/start$DESKNAME."
				fi
			fi
			
			ln -s $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.bm $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.xbm
			ln -s $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.pm $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.xpm
			
			echo "Done."
			echo "To change the login logo, edit $DESTDIR/etc/dt/appconfig/icons/C/dtlogin-$DESKNAME.[xbm|xpm]. "

		fi
	fi
fi
